#ident	"@(#)termio.h	1.3 91/04/01"
#ifndef _SYS_TERMIO_H
#define _SYS_TERMIO_H
/*
 *   Portions Copyright 1983-1990 The Santa Cruz Operation, Inc
 *		      All Rights Reserved
 */
/*	Copyright (c) 1984, 1986, 1987, 1988 AT&T	*/
/*	  All Rights Reserved  	*/

/*	THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF AT&T	*/
/*	The copyright notice above does not evidence any   	*/
/*	actual or intended publication of such source code.	*/

/*	Copyright (c) 1987, 1988 Microsoft Corporation	*/
/*	  All Rights Reserved	*/

/*	This Module contains Proprietary Information of Microsoft  */
/*	Corporation and should be treated as Confidential.	   */

/*
 *	Copyright (C) The Santa Cruz Operation, 1988, 1989, 1990.
 *	This Module contains Proprietary Information of
 *	The Santa Cruz Operation and should be treated as Confidential.
 */

#define	NCC	8

/* control characters */
#define	VINTR	0
#define	VQUIT	1
#define	VERASE	2
#define	VKILL	3
#define	VEOF	4
#define	VEOL	5
#define	VEOL2	6
#define	VMIN	4
#define	VTIME	5
#define	VSWTCH	7

/*
 * control characters adopted
 * from Xenix termio.h
 */
#define	VCEOF	NCC		/* RESERVED true EOF char (V7 compatability) */
#define	VCEOL	(NCC + 1)	/* RESERVED true EOL char */


#define	CNUL	0
#define	CDEL	0377

/* default control chars */
#define	CESC	'\\'
#define	CINTR	0177	/* DEL  cntl ? */
#define	CQUIT	034	/* FS,  cntl \ */
#define	CERASE	010	/* BS,  cntl H */
#define	CKILL	025	/* NAK, cntl U */
#define	CEOF	04	/* EOT, cntl D */
#define	CSTART	021	/* DC1, cntl Q */
#define	CSTOP	023	/* DC3, cntl S */
#define	CSWTCH	032	/* SUB, cntl Z */
#define	CNSWTCH	0
#define CSUSP	032	/* SUB, cntl Z - POSIX default suspend character */


/* input modes */
#define	IGNBRK	0000001
#define	BRKINT	0000002
#define	IGNPAR	0000004
#define	PARMRK	0000010
#define	INPCK	0000020
#define	ISTRIP	0000040
#define	INLCR	0000100
#define	IGNCR	0000200
#define	ICRNL	0000400
#define	IUCLC	0001000
#define	IXON	0002000
#define	IXANY	0004000
#define	IXOFF	0010000
#define DOSMODE	0100000

/* output modes */
#define	OPOST	0000001
#define	OLCUC	0000002
#define	ONLCR	0000004
#define	OCRNL	0000010
#define	ONOCR	0000020
#define	ONLRET	0000040
#define	OFILL	0000100
#define	OFDEL	0000200
#define	NLDLY	0000400
#define	NL0	0
#define	NL1	0000400
#define	CRDLY	0003000
#define	CR0	0
#define	CR1	0001000
#define	CR2	0002000
#define	CR3	0003000
#define	TABDLY	0014000
#define	TAB0	0
#define	TAB1	0004000
#define	TAB2	0010000
#define	TAB3	0014000
#define	BSDLY	0020000
#define	BS0	0
#define	BS1	0020000
#define	VTDLY	0040000
#define	VT0	0
#define	VT1	0040000
#define	FFDLY	0100000
#define	FF0	0
#define	FF1	0100000

/* control modes */
#define	CBAUD	0000017
#define	B0	0
#define	B50	0000001
#define	B75	0000002
#define	B110	0000003
#define	B134	0000004
#define	B150	0000005
#define	B200	0000006
#define	B300	0000007
#define	B600	0000010
#define	B1200	0000011
#define	B1800	0000012
#define	B2400	0000013
#define	B4800	0000014
#define	B9600	0000015
#define	B19200	0000016
#define EXTA	0000016
#define	B38400	0000017
#define EXTB	0000017
#define	CSIZE	0000060
#define	CS5	0
#define	CS6	0000020
#define	CS7	0000040
#define	CS8	0000060
#define	CSTOPB	0000100
#define	CREAD	0000200
#define	PARENB	0000400
#define	PARODD	0001000
#define	HUPCL	0002000
#define	CLOCAL	0004000
#define RCV1EN	0010000
#define	XMT1EN	0020000
#define	LOBLK	0040000
#define	XCLUDE	0100000		/* *V7* exclusive use coming fron XENIX */
/*
 * XENIX backwards compatibility 
 */
#define	XLOBLK	0010000
#define	CTSFLOW	0020000
#define	RTSFLOW	0040000

/* line discipline 0 modes */
#define	ISIG	0000001
#define	ICANON	0000002
#define	XCASE	0000004
#define	ECHO	0000010
#define	ECHOE	0000020
#define	ECHOK	0000040
#define	ECHONL	0000100
#define	NOFLSH	0000200

#ifndef u3b15
#define	SSPEED	13	/* default speed: 9600 baud */
#else
#define SSPEED	9	/* default speed: 1200 baud */
#endif


typedef unsigned char   cc_t;           /* unsigned integral type */
typedef unsigned long   speed_t;        /* unsigned integral type */
typedef unsigned short  tcflag_t;       /* unsigned integral type */

/*
 * Ioctl control packet
 */
struct termio {
	unsigned short	c_iflag;	/* input modes */
	unsigned short	c_oflag;	/* output modes */
	unsigned short	c_cflag;	/* control modes */
	unsigned short	c_lflag;	/* line discipline modes */
	char	c_line;		/* line discipline */
	unsigned char	c_cc[NCC];	/* control chars */
};

/* POSIX termios - 'x' to avoid 'p', 'P', and 'X' conflicts */
#define         XIOC            ('x'<<8)
#define         XCGETA          (XIOC|1)
#define         XCSETA          (XIOC|2)
#define         XCSETAW         (XIOC|3)
#define         XCSETAF         (XIOC|4)

#define	IOCTYPE	0xff00

#define	TIOC	('T'<<8)
#define	TCGETA	(TIOC|1)
#define	TCSETA	(TIOC|2)
#define	TCSETAW	(TIOC|3)
#define	TCSETAF	(TIOC|4)
#define	TCSBRK	(TIOC|5)
#define	TCXONC	(TIOC|6)
#define	TCFLSH	(TIOC|7)

#ifdef u3b15
#define TTYTYPE (TIOC|8)
#endif

#define TIOCGWINSZ	(TIOC|104)
#define TIOCSWINSZ	(TIOC|103)
#define TIOCGPGRP	(TIOC|119)/* get pgrp of tty */
#define TIOCSPGRP	(TIOC|118)/* set pgrp of tty */

#define	TCDSET	(TIOC|32)
#define	RTS_TOG	(TIOC|33)	/* 386 - "RTS" toggle define 8A1 protocol */

#define	LDIOC	('D'<<8)
#define	LDOPEN	(LDIOC|0)
#define	LDCLOSE	(LDIOC|1)
#define	LDCHG	(LDIOC|2)
#define	LDGETT	(LDIOC|8)
#define	LDSETT	(LDIOC|9)

/*
 * Merged product XENIX ioctl extensions.
 */
#define	tIOC	('t'<<8)
#define TIOCGETD        (tIOC|0)                /* V7 */
#define TIOCSETD        (tIOC|1)                /* V7 */
#define TIOCHPCL        (tIOC|2)                /* V7 */
#define TIOCGETP        (tIOC|8)
#define TIOCSETP        (tIOC|9)
#define TIOCSETN        (tIOC|10)               /* V7 */
#define TIOCEXCL        (tIOC|13)               /* V7 */
#define TIOCNXCL        (tIOC|14)               /* V7 */
#define TIOCFLUSH       (tIOC|16)               /* V7 */
#define TIOCSETC        (tIOC|17)               /* V7 */
#define TIOCGETC        (tIOC|18)               /* V7 */

/*
 * These are retained for backward compatibility.
 */
#define	DIOC	('d'<<8)
#define DIOCGETP        (DIOC|8)                /* V7 */
#define DIOCSETP        (DIOC|9)                /* V7 */

#define FIOCLEX         (('f'<<8)|1)            /* V7 */
#define FIONCLEX        (('f'<<8)|2)            /* V7 */
/*
 * Returns a non-zero value if there
 * are characters in the input queue.
 */
#define FIORDCHK        (('f'<<8)|3)            /* V7 */

/*
 * Terminal types
 */
#define	TERM_NONE	0	/* tty */
#define	TERM_TEC	1	/* TEC Scope */
#define	TERM_V61	2	/* DEC VT61 */
#define	TERM_V10	3	/* DEC VT100 */
#define	TERM_TEX	4	/* Tektronix 4023 */
#define	TERM_D40	5	/* TTY Mod 40/1 */
#define	TERM_H45	6	/* Hewlitt-Packard 45 */
#define	TERM_D42	7	/* TTY Mod 40/2B */

/*
 * Terminal flags
 */
#define TM_NONE		0000	/* use default flags */
#define TM_SNL		0001	/* special newline flag */
#define TM_ANL		0002	/* auto newline on column 80 */
#define TM_LCF		0004	/* last col of last row special */
#define TM_CECHO	0010	/* echo terminal cursor control */
#define TM_CINVIS	0020	/* do not send esc seq to user */
#define TM_SET		0200	/* must be on to set/res flags */

/*
 * structure of ioctl arg for LDGETT and LDSETT
 */
struct	termcb	{
	char	st_flgs;	/* term flags */
	char	st_termt;	/* term type */
	char	st_crow;	/* gtty only - current row */
	char	st_ccol;	/* gtty only - current col */
	char	st_vrow;	/* variable row */
	char	st_lrow;	/* last row */
};

/*
 * structure of ioctl arg for AIOCSETSS
 */

struct	termss {
	char	ss_start; 	/* output start char */
	char 	ss_stop;	/* output stop char */
};

/* vvv POSIX termios extensions vvv */
/*
 * new c_lflag (local) modes
 */
#define         IEXTEN          0000400 /* enable extended functions */
#define         TOSTOP          0001000 /* SIGTTOU on background output */

/*
 * new special control characters in termios.c_cc[]
 */
#define         NCCS            NCC+5   /* size of termios.c_cc[] */
#define         VSUSP           10      /* suspend character */
#define         VSTART          11      /* start character */
#define         VSTOP           12      /* stop character */

/*
 * POSIX tcsetattr(,optional_actions,) parameter
 */
#define         TCSANOW         XCSETA
#define         TCSADRAIN       XCSETAW
#define         TCSADFLUSH      XCSETAF
#define         TCSAFLUSH       XCSETAF

/*
 * POSIX tcflush(, queue_selector) and tcflow(, action) functions
 */
#define         TCIFLUSH        0       /* flush data received but not read */
#define         TCOFLUSH        1       /* flush data written but not transmitted */
#define         TCIOFLUSH       2       /* flush both cases above */

#define         TCOOFF          0       /* suspend output */
#define         TCOON           1       /* restart suspended output */
#define         TCIOFF          2       /* transmit STOP character */
#define         TCION           3       /* restart suspended input */

/*
 * POSIX ioctl control packet
 */
struct termios {
        tcflag_t        c_iflag;        /* input modes */
        tcflag_t        c_oflag;        /* output modes */
        tcflag_t        c_cflag;        /* control modes */
        tcflag_t        c_lflag;        /* local (line discipline) modes */
        char            c_line;         /* line discipline */
        cc_t            c_cc[NCCS];     /* control chars */
        char            c_ispeed;       /* input baud rate */
        char            c_ospeed;       /* output baud rate */
};

/*
 * POSIX termios function macros
 */

#define tcgetattr(fd, termios_p)	ioctl(fd, XCGETA, termios_p)
#define tcsetattr(fd, opt, termios_p)	ioctl(fd, opt, termios_p)
#define tcflow(fd, action)		ioctl(fd, TCXONC, action)
#define tcflush(fd, queue_select)	ioctl(fd, TCFLSH, queue_select)
#define tcdrain(fd)			ioctl(fd, TCSBRK, 1)
#define tcsendbreak(fd, duration)	ioctl(fd, TCSBRK, 0, duration)

/* ^^^ POSIX termios extensions ^^^ */

#endif /* _SYS_TERMIO_H */
