#ident	"@(#)werrno.h	1.2	90/08/08"
#ifndef _SYS_WERRNO_H
#define _SYS_WERRNO_H
#ident "@(#) werrno.h 22.1 90/01/15 "
#ident "@(#)werrno.h	1.2 89/09/29"
#ident "@(#) werrno.h 1.2 89/07/21 "
/*
 *	      UNIX is a registered trademark of AT&T
 *		Portions Copyright 1976-1989 AT&T
 */

/*
 *	Copyright (C) JSB Computer Systems Ltd, 1988.
 *
 *	This Module contains Proprietary Information of
 *	JSB Computer Systems Ltd, and should be treated
 *	as Confidential.
 */

/****************************************************************************** 
 *                                                                            *
 *    This file contains all the current error conditions for the             * 
 *                                                                            *
 *    JSB MultiView toolkit.                                                  * 
 *                                                                            *
 ******************************************************************************/

#define  ZEROBUFSIZ    1 /* Zero returned for buffer size                     */
#define  NOTCFILE      2 /* Cannot get termcap file                           */
#define  NOMEMORY      3 /* Cannot get sufficient memory                      */
#define  BADROW        4 /* Row error i.e. too high/low                       */
#define  BADCOL        5 /* Col error  "    "    "   "                        */
#define  SCREENEDGE    6 /* Attempt to write over screen edge                 */
#define  BRIGHTCORNER  7 /* Attempt to write to bottom right corner of screen */
#define  BADSEQUENCE   8 /* Unrecognised sequence supplied                    */
#define  NOSEQUENCE    9 /* ESC/CTRL sequence not available                   */
#define  NOPARAM      10 /* Vital parameter not supplied                      */
#define  NOOPENFILE   11 /* Cannot open filename supplied                     */
#define  BADPID       12 /* No process with specified pid exists              */
#define  BADPGRP      13 /* No process group with specified pgrp exists       */
#define  BADSIGTYPE   14 /* No such signal exists                             */
#define  BADHANDLE    15 /* Invalid window handle specified                   */
#define  BADSYSCALL   16 /* Internal mview system call fail                   */
#define  BADTITLE     17 /* Invalid title data                                */
#define  FIXDWINERR   18 /* Illegal attempt made to set/get fixed state win   */
#define  WINEDGERR    19 /* Must always have one window edge on screen        */
#define  WINSKEWERR   20 /* Illegal separation of window plane and borders    */
#define  BADCURSPOS   21 /* Illegal cursor position                           */
#define  NOWINLEFT    22 /* All heavyweight windows taken                     */
#define  WINMKFAIL    23 /* Can't make another window                         */
#define  INTERNERR    24 /* Internal mview error                              */
#define  NOTUI        25 /* This functionality restricted to new interface    */
#define  WINHASKBD    26 /* Can't perform operation on window with keyboard   */
#define  SYSDATAERR   27 /* Can't obtain data from system                     */
#define  WRITEFAIL    28 /* Fail to put data on standard input                */
#define  BADLEN       29 /* Invalid length specified                          */
#define  BADDEVNAM    30 /* Invalid device name                               */
#define  MENUACTIVE   31 /* Invalid request: Menu currently active on this win*/
#define  BADMENUITEM  32 /* Invalid menu item specified                       */
#define  NUMOPTS      33 /* Invalid number of options specified               */
#define  BIGMENUOPT   34 /* Menu option too long                              */
#define  NOMENU       35 /* No menu to activate                               */
#define  BADMENUSTYLE 36 /* Invalid menu style specified                      */
#define  BADSTARTOPT  37 /* Invalid menu start option specified               */
#define  BADOPTYPE    38 /* Invalid menu option type specified                */
#define  XFERABORT    39 /* Transfer operation aborted                        */
#define  SYSDATAFAIL  40 /* Request for kernel data failed                    */
#define  NOPLANE      41 /* Neither character nor attribute plane specified   */
#define  BADFLAG      42 /* Either value out of range or bad bit setting      */
#define  CLOSE_ERROR  43 /* Fail to close heavyweight window.                 */
#define  NOREAD       44 /* Fail to read character from keyboard              */
#define  NOACCFLDS    45 /* No accept fields configured                       */
#define  BIGACCFLDS   46 /* Too many accept fields configured                 */
#define  BIGDSPFLDS   47 /* Too many display fields configured                */
#define  BIGTOGOPTS   48 /* Too many toggle options configured                */
#define  NUMBADLEN    49 /* Buffer for numeric field too small                */
#define  FREBADLEN    50 /* Buffer for free format field too small            */
#define  NOFORMDATA   51 /* Form structure not configured                     */
#define  NUMINITFAIL  52 /* Fail to format numeric field with default         */
#define  BADSTRING    53 /* No string found to input to window.               */
#define  OVERWRITEVAL 54 /* Attempt to overwrite variable which is set        */
#define  UNINITIALISD 55 /* Attempt to call function needing initialise()     */
#define  INITFAIL     56 /* Failure of initialise(), cannot proceed           */

#endif	/* _SYS_WERRNO_H */
