#
#	@(#) tvi.por 22.1 89/11/14 
#
#	Copyright (C) The Santa Cruz Operation, 1985, 1986, 1987, 1988.
#	This Module contains Proprietary Information of
#	The Santa Cruz Operation and Microsoft Corportation
#	and should be treated as Confidential.
#

# SCO Mapchan File
#
# The descriptions in this file are provided for informational
# purposes only, and are intended for the exclusive use of the
# clients, customers, and licensees of The Santa Cruz Operation,
# Inc.  The Santa Cruz Operation does not warrant the correctness
# or suitability for any purpose of any information contained
# herein.

# This map file is for Televideo TVI924 terminals with the Portuguese
# keyboard option.
#

input
'@'	0xa7	# section sign
'['	0xc3	# A tilde
92	0xc7	# C cedilla
']'	0xd5	# O tilde
'{'	0xe3	# a tilde
'|'	0xe7	# c cedilla
'}'	0xf5	# o tilde
'~'	0xb0	# degree sign

output
0xa0	' '	# no break space
0xa1	'!'	# inverted !
0xa2	'c'	# cent sign
0xa3	'#'	# pound sign
0xa4	'x'	# currency sign
0xa5	'y'	# yen sign
0xa6	'I'	# broken bar
0xa7	'@'	# section sign
0xa8	'"'	# diaresis
0xa9	'c'	# copyright sign
0xaa	'a'	# feminine ordinal indicator
0xab	'<'	# angle quotation mark left
0xac	'^'	# not sign
0xad	'-'	# soft hyphen
0xae	'r'	# registered trade mark
0xaf	'^'	# macron
0xb0	'~'	# degree sign
0xb1	0x1b '$' 't' 0x1b '%'	# plus/minus sign
0xb2	'2'	# superscript 2
0xb3	'3'	# superscript 3
0xb4	39	# acute accent
0xb5	0x1b '$' '|' 0x1b '%'	# micro sign
0xb6	'p'	# paragraph sign
0xb7	0x1b '$' 's' 0x1b '%'	# middle dot
0xb8	','	# cedilla
0xb9	'1'	# superscript 1
0xba	'o'	# masculine ordinal indicator
0xbb	'>'	# angle quotation mark right
0xbc	'/'	# fraction one-quarter
0xbd	'/'	# fraction one-half
0xbe	'/'	# fraction three-quarter
0xbf	'?'	# inverted ?
0xc0	'A'	# A grave
0xc1	'A'	# A acute
0xc2	'A'	# A circumflex
0xc3	'['	# A tilde
0xc4	'A'	# A umlaut
0xc5	'A'	# A ring
0xc6	'A'	# AE ligature
0xc7	92	# C cedilla
0xc8	'E'	# E grave
0xc9	'E'	# E acute
0xca	'E'	# E circumflex
0xcb	'E'	# E umlaut
0xcc	'I'	# I grave
0xcd	'I'	# I acute
0xce	'I'	# I circumflex
0xcf	'I'	# I umlaut
0xd0	'D'	# capital Icelandic eth
0xd1	'N'	# N tilde
0xd2	'O'	# O grave
0xd3	'O'	# O acute
0xd4	'O'	# O circumflex
0xd5	']'	# O tilde
0xd6	'O'	# O umlaut
0xd7	'x'	# multiply operator
0xd8	0x1b '$' '}' 0x1b '%'	# O slash
0xd9	'U'	# U grave
0xda	'U'	# U acute
0xdb	'U'	# U circumflex
0xdc	'U'	# U umlaut
0xdd	'Y'	# Y acute
0xde	'P'	# capital Icelandic thorn
0xdf	0x1b '$' 'y' 0x1b '%'	# sharp ss
0xe0	'a'	# a grave
0xe1	'a'	# a acute
0xe2	'a'	# a circumflex
0xe3	'{'	# a tilde
0xe4	'a'	# a umlaut
0xe5	'a'	# a ring
0xe6	'a'	# ae ligature
0xe7	'|'	# c cedilla
0xe8	'e'	# e grave
0xe9	'e'	# e acute
0xea	'e'	# e circumflex
0xeb	'e'	# e umlaut
0xec	'i'	# i grave
0xed	'i'	# i acute
0xee	'i'	# i circumflex
0xef	'i'	# i umlaut
0xf0	'd'	# lowercase Icelandic eth
0xf1	'n'	# n tilde
0xf2	'o'	# o grave
0xf3	'o'	# o acute
0xf4	'o'	# o circumflex
0xf5	'}'	# o tilde
0xf6	'o'	# o umlaut
0xf7	'/'	# divide operator
0xf8	'o'	# o slash
0xf9	'u'	# u grave
0xfa	'u'	# u acute
0xfb	'u'	# u circumflex
0xfc	'u'	# u umlaut
0xfd	'y'	# y acute
0xfe	'p'	# lowercase Icelandic thorn
0xff	'y'	# y umlaut (ij ligature)

compose 0x1f	# ^_ (control underscore)

'+' '+' '#'     # hash
'S' '/' '$'     # dollar sign
'S' '|' '$'     # dollar sign
's' '/' '$'     # dollar sign
's' '|' '$'     # dollar sign
'A' 'A' '@'     # at sign
'a' 'a' '@'     # at sign
'(' '(' '['     # open square bracket
'/' '/' 92      # backslash
')' ')' ']'     # close square bracket
'>' '<' '^'     # caret
39 '<'  '`'     # backquote (grave accent)
'(' '-' '{'     # open curly brace
'/' '<' '|'     # vertical bar (pipe)
'/' '^' '|'     # vertical bar (pipe)
')' '-' '}'     # close curly brace
'=' '=' '~'     # tilde
'_' '_' 0x1f    # ^_ (control underscore)
' ' ' ' 0xa0    # no break space
'!' '!' 0xa1    # inverted !
'C' '/' 0xa2    # cent sign
'C' '|' 0xa2    # cent sign
'c' '/' 0xa2    # cent sign
'c' '|' 0xa2    # cent sign
'L' '-' 0xa3    # pound sign
'L' '=' 0xa3    # pound sign
'l' '-' 0xa3    # pound sign
'l' '=' 0xa3    # pound sign
'X' 'O' 0xa4    # currency sign
'x' 'o' 0xa4    # currency sign
'Y' '-' 0xa5    # yen sign
'Y' '=' 0xa5    # yen sign
'y' '-' 0xa5    # yen sign
'y' '=' 0xa5    # yen sign
'/' '!' 0xa6    # broken bar
'|' '/' 0xa6    # broken bar
'|' '|' 0xa6    # broken bar
'S' '!' 0xa7    # section sign
'S' 'O' 0xa7    # section sign
's' '!' 0xa7    # section sign
's' 'o' 0xa7    # section sign
'.' '.' 0xa8    # diaresis
'C' 'O' 0xa9    # copyright sign
'c' 'o' 0xa9    # copyright sign
'A' '-' 0xaa    # feminine ordinal indicator
'A' '_' 0xaa    # feminine ordinal indicator
'a' '-' 0xaa    # feminine ordinal indicator
'a' '_' 0xaa    # feminine ordinal indicator
'<' '<' 0xab    # angle quotation mark left
'-' '!' 0xac    # not sign
'-' '|' 0xac    # not sign
'-' '-' 0xad    # soft hyphen
'R' 'O' 0xae    # registered trade mark
'r' 'o' 0xae    # registered trade mark
'-' '<' 0xaf    # macron
'-' '^' 0xaf    # macron
'_' '<' 0xaf    # macron
'_' '^' 0xaf    # macron
'O' ' ' 0xb0    # degree sign
'o' ' ' 0xb0    # degree sign
'+' '-' 0xb1    # plus/minus sign
'2' '<' 0xb2    # superscript 2
'2' '^' 0xb2    # superscript 2
'3' '<' 0xb3    # superscript 3
'3' '^' 0xb3    # superscript 3
39 39   0xb4    # acute accent
'U' '/' 0xb5    # micro sign
'u' '/' 0xb5    # micro sign
'P' '!' 0xb6    # paragraph sign
'p' '!' 0xb6    # paragraph sign
'.' '<' 0xb7    # middle dot
'.' '^' 0xb7    # middle dot
',' ',' 0xb8    # cedilla
'1' '<' 0xb9    # superscript 1
'1' '^' 0xb9    # superscript 1
'O' '-' 0xba    # masculine ordinal indicator
'O' '_' 0xba    # masculine ordinal indicator
'o' '-' 0xba    # masculine ordinal indicator
'o' '_' 0xba    # masculine ordinal indicator
'>' '>' 0xbb    # angle quotation mark right
'1' '4' 0xbc    # fraction one-quarter
'1' '2' 0xbd    # fraction one-half
'3' '4' 0xbe    # fraction three-quarter
'?' '?' 0xbf    # inverted ?
'A' '(' 0xc0    # A grave
'A' '`' 0xc0    # A grave
'A' 39  0xc1    # A acute
'A' '>' 0xc2    # A circumflex
'A' '^' 0xc2    # A circumflex
'A' '=' 0xc3    # A tilde
'A' '~' 0xc3    # A tilde
'A' '"' 0xc4    # A umlaut
'A' '*' 0xc5    # A ring
'A' 'E' 0xc6    # AE ligature
'C' ',' 0xc7    # C cedilla
'E' '(' 0xc8    # E grave
'E' '`' 0xc8    # E grave
'E' 39  0xc9    # E acute
'E' '>' 0xca    # E circumflex
'E' '^' 0xca    # E circumflex
'E' '"' 0xcb    # E umlaut
'I' '(' 0xcc    # I grave
'I' '`' 0xcc    # I grave
'I' 39  0xcd    # I acute
'I' '>' 0xce    # I circumflex
'I' '^' 0xce    # I circumflex
'I' '"' 0xcf    # I umlaut
'D' '-' 0xd0    # capital Icelandic eth
'D' 'H' 0xd0    # capital Icelandic eth
'N' '=' 0xd1    # N tilde
'N' '~' 0xd1    # N tilde
'O' '(' 0xd2    # O grave
'O' '`' 0xd2    # O grave
'O' 39  0xd3    # O acute
'O' '>' 0xd4    # O circumflex
'O' '^' 0xd4    # O circumflex
'O' '=' 0xd5    # O tilde
'O' '~' 0xd5    # O tilde
'O' '"' 0xd6    # O umlaut
'X' '-' 0xd7    # multiply operator
'x' '-' 0xd7    # multiply operator
'O' '/' 0xd8    # O slash
'U' '(' 0xd9    # U grave
'U' '`' 0xd9    # U grave
'U' 39  0xda    # U acute
'U' '>' 0xdb    # U circumflex
'U' '^' 0xdb    # U circumflex
'U' '"' 0xdc    # U umlaut
'Y' 39  0xdd    # Y acute
'P' '1' 0xde    # capital Icelandic thorn
'T' 'H' 0xde    # capital Icelandic thorn
'S' 'S' 0xdf    # sharp ss
's' 's' 0xdf    # sharp ss
'a' '(' 0xe0    # a grave
'a' '`' 0xe0    # a grave
'a' 39  0xe1    # a acute
'a' '>' 0xe2    # a circumflex
'a' '^' 0xe2    # a circumflex
'a' '=' 0xe3    # a tilde
'a' '~' 0xe3    # a tilde
'a' '"' 0xe4    # a umlaut
'a' '*' 0xe5    # a ring
'a' 'e' 0xe6    # ae ligature
'c' ',' 0xe7    # c cedilla
'e' '(' 0xe8    # e grave
'e' '`' 0xe8    # e grave
'e' 39  0xe9    # e acute
'e' '>' 0xea    # e circumflex
'e' '^' 0xea    # e circumflex
'e' '"' 0xeb    # e umlaut
'i' '(' 0xec    # i grave
'i' '`' 0xec    # i grave
'i' 39  0xed    # i acute
'i' '>' 0xee    # i circumflex
'i' '^' 0xee    # i circumflex
'i' '"' 0xef    # i umlaut
'd' '-' 0xf0    # lowercase Icelandic eth
'd' 'h' 0xf0    # lowercase Icelandic eth
'n' '=' 0xf1    # n tilde
'n' '~' 0xf1    # n tilde
'o' '(' 0xf2    # o grave
'o' '`' 0xf2    # o grave
'o' 39  0xf3    # o acute
'o' '>' 0xf4    # o circumflex
'o' '^' 0xf4    # o circumflex
'o' '=' 0xf5    # o tilde
'o' '~' 0xf5    # o tilde
'o' '"' 0xf6    # o umlaut
':' '-' 0xf7    # divide operator
'o' '/' 0xf8    # o slash
'u' '(' 0xf9    # u grave
'u' '`' 0xf9    # u grave
'u' 39  0xfa    # u acute
'u' '>' 0xfb    # u circumflex
'u' '^' 0xfb    # u circumflex
'u' '"' 0xfc    # u umlaut
'y' 39  0xfd    # y acute
'p' '1' 0xfe    # lowercase Icelandic thorn
't' 'h' 0xfe    # lowercase Icelandic thorn
'y' '"' 0xff    # y umlaut (ij ligature)

beep

CONTROL

input
^A	1	# Function keys: control-A followed by @ through O

output
\E=	2	# Cursor control: escape = <x> <y>
\E	1	# Other escapes like \E$
