


     ECHO(C)		    Altos UNIX System V		       ECHO(C)



     Name
	  echo - echo

     Syntax
	  echo [-n] [ arg ] ...

     Description
	  The echo command writes its arguments	separated by blanks
	  and terminated by a new-line on the standard output. The -n
	  option prints	a line without the new-line; same as using the
	  \c escape sequence.

	  echo also understands	C-like escape conventions; beware of
	  conflicts with the shell's use of \:

	       \b   backspace
	       \c   print line without new-line
	       \f   form-feed
	       \n   new-line
	       \r   carriage return
	       \t   tab
	       \v   vertical tab
	       \\   backslash
	       \n   The	8-bit character	whose ASCII code is a 1, 2 or
		    3-digit octal number.  In all cases, n must	start
		    with a zero.  For example:

			 echo "\07"	- Echoes Ctrl-G.
			 echo "\007"	- Also echoes Ctrl-G.
			 echo "\065"	- Echoes the number ``5''.
			 echo "\0101"	- Echoes the letter ``A''.


	       The echo	command	is useful for producing	diagnostics in
	       command files and for sending known data	into a pipe.

     See Also
	  sh(C)

     Notes
	  When representing an 8-bit character by using	the escape
	  convention \0n, the n	must always be preceded	by the digit
	  zero (0).

	  For example, typing:	echo 'WARNING:\07' will	print the
	  phrase WARNING: and sound the	``bell'' on your terminal.
	  The use of single (or	double)	quotes (or two backslashes) is
	  required to protect the ``\''	that precedes the ``07''.

	  For the octal	equivalents of each character, see ascii(M).





     Page 1					     (printed 3/20/91)



