


     UUSTAT(C)		    Altos UNIX System V		     UUSTAT(C)



     Name
	  uustat - uucp	status inquiry and job control

     Syntax
	  uustat [-a]
	  uustat [-m]
	  uustat [-p]
	  uustat [-q]
	  uustat [ -kjobid ]
	  uustat [ -rjobid ]
	  uustat [ -ssystem ] [	-uuser ]

     Description
	  uustat will display the status of, or	cancel,	previously
	  specified uucp commands, or provide general status on	uucp
	  connections to other systems.	 Only one of the following
	  options can be specified with	uustat per command execution:

	  -a	    Output all jobs in queue.
	  -m	    Report the status of accessibility of all
		    machines.
	  -p	    Execute a ``ps -flp'' for all the process-ids that
		    are	in the lock files.
	  -q	    List the jobs queued for each machine.  If a
		    status file	exists for the machine,	its date, time
		    and	status information are reported.  In addition,
		    if a number	appears	in () next to the number of C
		    or X files,	it is the age in days of the oldest
		    C./X. file for that	system.	 The Retry field
		    represents the number of hours until the next
		    possible call.  The	Count is the number of failure
		    attempts.  NOTE: for systems with a	moderate
		    number of outstanding jobs,	this could take	30
		    seconds or more of real-time to execute.  As an
		    example of the output produced by the -q option:

		    eagle  3C  04/07-11:07NO DEVICES AVAILABLE
		    mh3bs3 2C  07/07-10:42SUCCESSFUL

		    The	above output tells how many command files are
		    waiting for	each system.  Each command file	may
		    have zero or more files to be sent (zero means to
		    call the system and	see if work is to be done).
		    The	date and time refer to the previous
		    interaction	with the system	followed by the	status
		    of the interaction.
	  -kjobid   Kill the uucp request whose	job identification is
		    jobid.  The	killed uucp request must belong	to the
		    person issuing the uustat command unless one is
		    the	super-user.
	  -rjobid   Rejuvenate jobid. The files	associated with	jobid
		    are	touched	so that	their modification time	is set



     Page 1					     (printed 3/20/91)






     UUSTAT(C)		    Altos UNIX System V		     UUSTAT(C)



		    to the current time.  This prevents	the cleanup
		    daemon from	deleting the job until the jobs
		    modification time reaches the limit	imposed	by the
		    daemon.

	  Either or both of the	following options can be specified
	  with uustat:

	  -ssys	    Report the status of all uucp requests for remote
		    system sys.
	  -uuser    Report the status of all uucp requests issued by
		    user.

	  Output for both the -s and -u	options	has the	following
	  format:

	  eaglen0000 4/07-11:01:03(POLL)
	  eagleN1bd7 4/07-11:07Seagledan522 /usr/dan/A
	  eagleC1bd8 4/07-11:07Seagledan59 D.3b2al2ce4924
		     4/07-11:07Seagledanrmail mike

	  With the above two options, the first	field is the jobid of
	  the job.  This is followed by	the date/time.	The next field
	  is either an 'S' or 'R' depending on whether the job is to
	  send or request a file.  This	is followed by the user-id of
	  the user who queued the job.	The next field contains	the
	  size of the file, or in the case of a	remote execution (
	  rmail	- the command used for remote mail), the name of the
	  command.  When the size appears in this field, the file name
	  is also given.  This can either be the name given by the
	  user or an internal name (e.g., D.3b2alce4924) that is
	  created for data files associated with remote	executions
	  (rmail in this example).
	  When no options are given, uustat outputs the	status of all
	  uucp requests	issued by the current user.
     Files
	  /usr/spool/uucp/*   spool directories
     See Also
	  uucp(C)
     Standards Conformance
	  uustat is conformant with:
	  AT&T SVID Issue 2, Select Code 307-127;
	  and The X/Open Portability Guide II of January 1987.












     Page 2					     (printed 3/20/91)



