


     VMSTAT(C)		    Altos UNIX System V		     VMSTAT(C)



     Name
	  vmstat - report paging and system statistics

     Syntax
	  vmstat [ -fs ] [ -n namelist ] [ -l lines ] [	interval [
	  count	]]

     Description
	  vmstat reports some statistics kept by the system on
	  processes, demand paging, and	cpu and	trap activity.	Three
	  types	of reports are available:

	  (default)
	       A summary of the	number of processes in various states,
	       paging activity,	system activity, and cpu cycle
	       consumption.

	  -f   Number of fork(S)'s done.

	  -s   A verbose listing of paging and trap activity.

	  If no	interval or count is specified,	the totals since
	  system bootup	are displayed.

	  If an	interval is given, the number of events	that have
	  occurred in the last interval	seconds	is shown.  If no count
	  is specified,	this display is	repeated forever every
	  interval seconds.  Otherwise,	when a count is	also
	  specified, the information is	displayed count	times.

	  Other	flags that may be specified include:

	  -n namelist
	       Use file	namelist as an alternate symbol	table instead
	       of /unix.

	  -l lines
	       For the default display,	repeat the header every	lines
	       reports (default	is 20).

	  The fields in	the default report are:

	  procs
	       The number of processes which are:

	       r    In the run queue.

	       b    Blocked waiting for	resources.

	       w    Swapped out.

	       These values always reflect the current situation, even



     Page 1					     (printed 3/20/91)






     VMSTAT(C)		    Altos UNIX System V		     VMSTAT(C)



	       if the totals since boot	are being displayed.

	  paging
	       Reports on the performance of the demand	paging system.
	       Unless the totals since boot are	being displayed, this
	       information is averaged over the	proceeding interval
	       seconds:

	       frs Free	swap space.

	       dmd  Demand zero	and demand fill	pages.

	       sw   Pages on swap.

	       cch  Pages in cache.

	       fil  Pages on file.

	       pft  Protection faults.

	       frp  Pages freed.

	       pos  Processes swapped out successfully.

	       pif  Processes swapped out unsuccessfully.

	       rso  Regions swapped out.

	       rsi  Regions swapped in.

	  system
	       Reports on the general system activity.	Unless the
	       totals since boot are being shown, these	figures	are
	       averaged	over the last interval seconds:

	       sy   Number of system calls.

	       cs   Number of context switches.

	  cpu  Percentage of cpu cycles	spent in various operating
	       modes:

	       us   User.

	       su   System.

	       id   Idle.

	       This information	may not	be displayed on	some systems.

	  The -f and -s	reports	are a series of	lines of the form:




     Page 2					     (printed 3/20/91)






     VMSTAT(C)		    Altos UNIX System V		     VMSTAT(C)



	       number description

	  which	means that number of the items described by
	  description happened (either since boot or in	the last
	  interval seconds, as appropriate).  These reports should be
	  self-explanatory.

     Files
	  /unix
	       Default namelist.

	  /dev/kmem
	       Default source of statistics.

     See Also
	  fork(S), ps(C), pstat(C)

     Authorization
	  The behavior of this utility is affected by assignment of
	  the mem authorization, which is usually reserved for system
	  administrators.  If you do not have this authorization, the
	  command will not work.  Refer	to the ``Using a Trusted
	  System'' chapter of the User's Guide for more	details.
































     Page 3					     (printed 3/20/91)



