


     XBACKUP(F)		    Altos UNIX System V		    XBACKUP(F)



     Name
	  xbackup - XENIX incremental dump tape	format

     Description
	  The xbackup and xrestore commands are	used to	write and read
	  incremental dump magnetic tapes.

	  The backup tape consists of a	header record, some bit	mask
	  records, a group of records describing file system
	  directories, a group of records describing file system
	  files, and some records describing a second bit mask.

	  The header record and	the first record of each description
	  have the format described by the structure included by:

		       #include	<dumprestor.h>

	  Fields in the	dumprestor structure are described below.

	  NTREC	is the number of 512 byte blocks in a physical tape
	  record.  MLEN	is the number of bits in a bit map word.  MSIZ
	  is the number	of bit map words.

	  The TS_ entries are used in the c_type field to indicate
	  what sort of header this is.	The types and their meanings
	  are as follows:

	  TS_TAPE      Tape volume label.

	  TS_INODE     A file or directory follows. The	c_dinode field
		       is a copy of the	disk inode and contains	bits
		       telling what sort of file this is.

	  TS_BITS      A bit mask follows. This	bit mask has one bit
		       for each	inode that was backed up.

	  TS_ADDR      A subblock to a file (TS_INODE).	 See the
		       description of c_count below.

	  TS_END       End of tape record.

	  TS_CLRI      A bit mask follows. This	bit mask contains one
		       bit for all inodes that were empty on the file
		       system when backed up.

	  MAGIC	       All header blocks have this number in c_magic.

	  CHECKSUM     Header blocks checksum to this value.







     Page 1					     (printed 3/20/91)






     XBACKUP(F)		    Altos UNIX System V		    XBACKUP(F)



	  The fields of	the header structure are as follows:

	  c_type       The type	of the header.

	  c_date       The date	the backup was taken.

	  c_ddate      The date	the file system	was backed up.

	  c_volume     The current volume number of the	backup.

	  c_tapea      The current block number	of this	record.	This
		       is counting 512 byte blocks.

	  c_inumber    The number of the inode being backed up if this
		       is of type TS_INODE.

	  c_magic      This contains the value MAGIC above, truncated
		       as needed.

	  c_checksum   This contains whatever value is needed to make
		       the block sum to	CHECKSUM.

	  c_dinode     This is a copy of the inode as it appears on
		       the file	system.

	  c_count      The following count of characters describes the
		       file.  A	character is zero if the block
		       associated with that character was not present
		       on the file system; otherwise, the character is
		       nonzero.	 If the	block was not present on the
		       file system no block was	backed up and it is
		       replaced	as a hole in the file.	If there is
		       not sufficient space in this block to describe
		       all of the blocks in a file, TS_ADDR blocks
		       will be scattered through the file, each	one
		       picking up where	the last left off.

	  c_addr       This is the array of characters that is used as
		       described above.

	  Each volume except the last ends with	a tapemark (read as an
	  end of file).	The last volume	ends with a TS_END block and
	  then the tapemark.

	  The structure	idates describes an entry of the file where
	  backup history is kept.

     See Also
	  xbackup(ADM),	xrestore(ADM), filesystem(F)

     Value Added
	  xbackup is an	extension of AT&T System V provided in Altos



     Page 2					     (printed 3/20/91)






     XBACKUP(F)		    Altos UNIX System V		    XBACKUP(F)



	  UNIX System V.






















































     Page 3					     (printed 3/20/91)



